# -*- coding: utf-8 -*-
# @Time : 2022/5/9 9:52
# @Author : xhr
# @File : opgg_Hero_Data.py
# @Software: PyCharm
import requests
import json
import time
def get_mid_str(s, start_str, stop_str):
    # 查找左边文本的结束位置
    start_pos = s.find(start_str)
    if start_pos == -1:
        return None
    start_pos += len(start_str)
    # 查找右边文本的起始位置
    stop_pos = s.find(stop_str, start_pos)
    if stop_pos == -1:
        return None

    # 通过切片取出中间的文本
    return s[start_pos:stop_pos]

 # 获取数据
def Get_Data(name,position):
    url = f'https://www.op.gg/champions/{name}/{position}/build'
    headers = {
        "User-agent": "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/95.0.4638.69 Safari/537.36",
        # 'accept-language': 'zh-CN,zh;q=0.9'
    }
    response = requests.get(url,headers=headers)
    if response.status_code == 200:
        HTML = get_mid_str(response.text,'<script id="__NEXT_DATA__" type="application/json">','</script><script src="https://s-lol-web.op.gg/scripts/vendor.js')
        Json = json.loads(HTML)
    else:
        time.sleep(5)
        Get_Data(name, position)
    return Json
 # 技能加点
def Order(Data):
    orderR = {
        'order':Data['props']['pageProps']['data']['skills'][0]['order'],
    }
    return json.dumps(orderR)
 # 天赋ID
def Runes_ID(Data):
    primary_rune_id = ''
    for LIST in Data['props']['pageProps']['data']['runes']:
        primary_page_id = LIST['primary_page_id']
        primary_rune_ids = LIST['primary_rune_ids']
        secondary_page_id = LIST['secondary_page_id']
        secondary_rune_ids = LIST['secondary_rune_ids']
        stat_mod_ids = LIST['stat_mod_ids']

    runes = {
        "primary_page_id":primary_page_id,
        "primary_rune_ids":primary_rune_ids,
        "secondary_page_id":secondary_page_id,
        "secondary_rune_ids":secondary_rune_ids,
        "stat_mod_ids":stat_mod_ids
    }
    return json.dumps(runes)
 # 装备ID
def Equipment_ID(Data):
    # 初始装备
    starter_items = Data['props']['pageProps']['data']['starter_items'][0]
    # 中期装备
    core_items =  Data['props']['pageProps']['data']['core_items'][0]
    # 鞋子
    try:
        boots1 = Data['props']['pageProps']['data']['boots'][0]
        boots2 = Data['props']['pageProps']['data']['boots'][1]
        boots3 = Data['props']['pageProps']['data']['boots'][2]

    except BaseException:
        boots1 = '0'
        boots2 = '0'
        boots3 = '0'
    Equipment = {
        'starter_items':starter_items,
        'core_items':core_items,
        'boots1':boots1,
        'boots2': boots2,
        'boots3': boots3,

    }
    return json.dumps(Equipment)
 # 英雄反制
def Counter(Data):
    hero_1_id =  Data['props']['pageProps']['data']['summary']['opponents'][0][0]['champion_id']
    hero_2_id =  Data['props']['pageProps']['data']['summary']['opponents'][0][1]['champion_id']
    hero_3_id =  Data['props']['pageProps']['data']['summary']['opponents'][0][2]['champion_id']
    hero_1_win =  Data['props']['pageProps']['data']['summary']['opponents'][0][0]['win_rate']
    hero_2_win =  Data['props']['pageProps']['data']['summary']['opponents'][0][1]['win_rate']
    hero_3_win =  Data['props']['pageProps']['data']['summary']['opponents'][0][2]['win_rate']
    Counter = {
        'hero_1_id':hero_1_id,
        'hero_2_id':hero_2_id,
        'hero_3_id':hero_3_id,
        'hero_1_win':hero_1_win,
        'hero_2_win': hero_2_win,
        'hero_3_win': hero_3_win,
    }
    return json.dumps(Counter)
 # 强烈对抗
def Strong_against(Data):
    hero_1_id =  Data['props']['pageProps']['data']['summary']['opponents'][1][0]['champion_id']
    hero_2_id =  Data['props']['pageProps']['data']['summary']['opponents'][1][1]['champion_id']
    hero_3_id =  Data['props']['pageProps']['data']['summary']['opponents'][1][2]['champion_id']
    hero_1_win =  Data['props']['pageProps']['data']['summary']['opponents'][1][0]['win_rate']
    hero_2_win =  Data['props']['pageProps']['data']['summary']['opponents'][1][1]['win_rate']
    hero_3_win =  Data['props']['pageProps']['data']['summary']['opponents'][1][2]['win_rate']
    strong_against = {
        'hero_1_id':hero_1_id,
        'hero_2_id':hero_2_id,
        'hero_3_id':hero_3_id,
        'hero_1_win':hero_1_win,
        'hero_2_win': hero_2_win,
        'hero_3_win': hero_3_win,
    }
    return json.dumps(strong_against)
 # 召唤师技能
def Spells(Data):
    # spells = Data['props']['pageProps']['data']['meta']['spells']
    spell = {
        'id1':Data['props']['pageProps']['data']['summoner_spells'][0]['ids'][0],
        'id2':Data['props']['pageProps']['data']['summoner_spells'][0]['ids'][1],
        'id3': Data['props']['pageProps']['data']['summoner_spells'][1]['ids'][0],
        'id4': Data['props']['pageProps']['data']['summoner_spells'][1]['ids'][1],
        'pick_rate1':round(Data['props']['pageProps']['data']['summoner_spells'][0]['pick_rate']*100,2),
        'pick_rate2':round(Data['props']['pageProps']['data']['summoner_spells'][1]['pick_rate']*100,2),
        'win_rate1':round(Data['props']['pageProps']['data']['summoner_spells'][0]['win']/Data['props']['pageProps']['data']['summoner_spells'][0]['play']*100,2),
        'win_rate2':round(Data['props']['pageProps']['data']['summoner_spells'][1]['win']/Data['props']['pageProps']['data']['summoner_spells'][1]['play']*100,2),
    }
    return json.dumps(spell)
 # 英雄详情
def hero_info():
    heroinfo = []
    url = f'https://www.op.gg/champions'
    headers = {
        "User-agent": "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/95.0.4638.69 Safari/537.36",
        # 'accept-language': 'zh-CN,zh;q=0.9'
    }
    response = requests.get(url,headers=headers)
    HTML = get_mid_str(response.text,'<script id="__NEXT_DATA__" type="application/json">','</script><script src="https://s-lol-web.op.gg/scripts/vendor.js')
    Json = json.loads(HTML)
    for info_list in Json['props']['pageProps']['championMetaList']:
        id = info_list['id']
        key = info_list['key']
        name = info_list['name']
        # print(name)
        is_rip = info_list['is_rip']
        if is_rip == False:
            for positions in info_list['positions']:
                list_info_dict = {}
                position = positions['name']
                list_info_dict['id'] = id
                list_info_dict['name'] = name
                list_info_dict['position'] = position
                heroinfo.append(list_info_dict)
    return json.dumps(heroinfo)
def clear_cache():
    url = 'https://mnn.tw/api/cloudflare/purge_cache/zoneid/7979ab1d3e356cb3304e5f47815d5a0c/token/l12FGswO9kTc7Pm1QOEVBFpqW9WLFT60'
    response = requests.get(url)
    print(response.text)

if __name__ == '__main__':
    JsonData = hero_info()
    HeroData = []
    for list in json.loads(JsonData):
        name = list['name'].lower().replace(' ','').replace("'",'').replace(".",'')
        if name == 'nunu&willump':
            name = 'nunu'
        if name == 'renataglasc':
            name = 'renata'
        if name == 'wukong':
            name = 'monkeyking'
        position = list['position'].lower()
        print(name,position)
        heroDATA = Get_Data(name,position)
        order = Order(heroDATA)
        runes_ID = Runes_ID(heroDATA)
        equipment_ID = Equipment_ID(heroDATA)
        counter = Counter(heroDATA)
        strong_against = Strong_against(heroDATA)
        spells = Spells(heroDATA)

        Hero_data_json = {
            'name':name,
            'position':position,
            'order':order,
            'runes':runes_ID,
            'equipment':equipment_ID,
            'counter':counter,
            'strong':strong_against,
            'spells':spells
        }
        # HeroData.append(json.dumps(Hero_data_json))
        with open(f'{name}{position}.json', 'w', encoding='utf-8') as file:
            file.write(json.dumps(Hero_data_json) + '\n')
        time.sleep(2)
    clear_cache()
    # Data = Get_Data()

